include wildcard.e
include graphics.e
include get.e
include diccio.e

constant INGLES = 1, OTROIDIOMA = 2
constant EXACTO = 1, CONTIENE = 2
constant F1 = 315, F2 = 316, F3 = 317, ESC = 27

constant LENGUAJE = 1, INTRO = 4, PULSAR = 5, ENCUENTRA = 6, TEXTO = 7, SALIDA = 8

constant letreros = {{"ENGLISH", "ESPAOL"},
                     {"EXACT", "EXACTO"},
                     {"CONTAIN", "CONTIENE"},
                     {"Enter the word: ", "Introduzca la palabra: "},
                     {"Press ENTER to continue ...", "Pulse ENTER para continuar ..."},
                     {"   %d matchs found", "   Se han encontrado %d coincidencias"},
                     {"Word", "Palabra"},
                     {"Exit", "Salir"}}
                     
sequence idioma
   idioma = "Spanish.txt"

integer destino, modo, code
   destino = INGLES
   modo = EXACTO

object NIL


procedure palabra()

   sequence texto, resultado
   integer pagcompleta
   
   puts(1, letreros[INTRO][destino])
   text_color(YELLOW)
   texto = gets(0)
   text_color(WHITE)
   texto = texto[1..length(texto)-1]
   if not(equal(texto, {})) then
      resultado = buscar(idioma, texto, destino, modo)
      puts(1, "\n")
   
      text_color(YELLOW)
      for n = 1 to length(resultado) do
         puts(1, "\n")
         puts(1, resultado[n][1])
         puts(1, " = ")
         puts(1, resultado[n][2])
         pagcompleta = not remainder(n, 15)
         if pagcompleta then
            puts(1, "\n\n")
            puts(1, letreros[PULSAR][destino])
            puts(1, "\n")
            NIL = wait_key()
            if NIL = ESC then
               exit
            end if
         end if
      end for
      text_color(WHITE)
      puts(1, "\n\n   ")
      printf(1, letreros[ENCUENTRA][destino], length(resultado))
      puts(1, "\n\n\n")
      puts(1, letreros[PULSAR][destino])
      NIL = gets(0)
   end if
end procedure

procedure cabecera()
   sequence traduccion
   if destino = INGLES then
      traduccion = letreros[LENGUAJE][INGLES] & "->" & letreros[LENGUAJE][OTROIDIOMA]
   else
      traduccion = letreros[LENGUAJE][OTROIDIOMA] & "->" & letreros[LENGUAJE][INGLES]
   end if
   text_color(YELLOW)
   position(1, 1)
   printf(1, "F1 = %s\tF2 = %s\tF3 = %s\tESC = %s \n\n", {letreros[TEXTO][destino],
      traduccion, letreros[modo + 1][destino], letreros[SALIDA][destino]})
   text_color(WHITE)
end procedure

clear_screen()

while 1 do
   cabecera()
   while 1 do
       code = wait_key()
       if code != -1 then
          if code = F1 then
             palabra()
             clear_screen()
             cabecera()
          elsif code = F2 then
             if destino = OTROIDIOMA then
                destino = INGLES
             else
                destino = OTROIDIOMA
             end if
             cabecera()
          elsif code = F3 then
             if modo = CONTIENE then
                modo = EXACTO
             else
                modo = CONTIENE
             end if
             cabecera()
          elsif code = ESC then
             exit
          end if
       end if
   end while
   if code = ESC then
      exit
   end if
end while
